#ifndef SSHZLIB_H
#define SSHZLIB_H

struct ssh_compress {
    char *name;
    void (*compress_init) (void);
    int (*compress) (unsigned char *block, int len,
		     unsigned char **outblock, int *outlen);
    void (*decompress_init) (void);
    int (*decompress) (unsigned char *block, int len,
		       unsigned char **outblock, int *outlen);
    int (*disable_compression) (void);
};

void zlib_compress_init(void);
int zlib_compress_block(unsigned char *block, int len,
			unsigned char **outblock, int *outlen);
void zlib_decompress_init(void);
int zlib_decompress_block(unsigned char *block, int len,
			  unsigned char **outblock, int *outlen);
int zlib_disable_compression(void);

const struct ssh_compress ssh_zlib = {
    "zlib",
    zlib_compress_init,
    zlib_compress_block,
    zlib_decompress_init,
    zlib_decompress_block,
    zlib_disable_compression
};

#endif